aboutsummaryrefslogtreecommitdiffstats
path: root/coin/provisioning/common/linux
diff options
context:
space:
mode:
authorRyan Chu <ryan.chu@qt.io>2018-03-06 14:37:35 +0100
committerSimon Hausmann <simon.hausmann@qt.io>2018-07-02 19:20:21 +0000
commit2b6f5f165dd91a9983d44c2ba432aadd256541b9 (patch)
tree9b43c305da21709e1100f8bbc116858174c9fb63 /coin/provisioning/common/linux
parentc6d9e433dfa899890b4279c773779659f8cb2626 (diff)
Provisioning: Install Docker-based test servers on Ubuntu 16.04
Build and cache docker images based on the configurations in testserver. 1. Download and install the docker engine and docker-compose extension. 2. Append address and hostname of test servers to CI environment. 3. Build and tag the docker images by the SHA-1 of server context. Task-number: QTQAINFRA-1686 Change-Id: Ib9b58d45856682ddec04af045e1eab18e14a85fb Reviewed-by: Jędrzej Nowacki <jedrzej.nowacki@qt.io> Reviewed-by: Frederik Gladhorn <frederik.gladhorn@qt.io>
Diffstat (limited to 'coin/provisioning/common/linux')
-rw-r--r--coin/provisioning/common/linux/testserver/apache2/Dockerfile6
-rw-r--r--coin/provisioning/common/linux/testserver/danted/Dockerfile9
-rwxr-xr-xcoin/provisioning/common/linux/testserver/danted/danted93
-rwxr-xr-xcoin/provisioning/common/linux/testserver/danted/danted-authenticating97
-rwxr-xr-xcoin/provisioning/common/linux/testserver/docker_testserver.sh58
-rw-r--r--coin/provisioning/common/linux/testserver/ftp-proxy/Dockerfile3
-rw-r--r--coin/provisioning/common/linux/testserver/squid/Dockerfile3
-rw-r--r--coin/provisioning/common/linux/testserver/vsftpd/Dockerfile6
8 files changed, 275 insertions, 0 deletions
diff --git a/coin/provisioning/common/linux/testserver/apache2/Dockerfile b/coin/provisioning/common/linux/testserver/apache2/Dockerfile
new file mode 100644
index 00000000..b502a008
--- /dev/null
+++ b/coin/provisioning/common/linux/testserver/apache2/Dockerfile
@@ -0,0 +1,6 @@
+FROM ubuntu:16.04
+RUN apt-get update && apt-get install -y apache2 libcgi-session-perl wget
+EXPOSE 80 443
+
+# install configurations and test data
+RUN wget https://tools.ietf.org/rfc/rfc3252.txt
diff --git a/coin/provisioning/common/linux/testserver/danted/Dockerfile b/coin/provisioning/common/linux/testserver/danted/Dockerfile
new file mode 100644
index 00000000..d706b7e7
--- /dev/null
+++ b/coin/provisioning/common/linux/testserver/danted/Dockerfile
@@ -0,0 +1,9 @@
+FROM ubuntu:16.04
+RUN apt-get update && apt-get install -y gdebi-core=0.9.5.7ubuntu1 wget
+RUN wget http://ppa.launchpad.net/dajhorn/dante/ubuntu/pool/main/d/dante/dante-server_1.4.1-1_amd64.deb
+RUN gdebi -n dante-server_1.4.1-1_amd64.deb
+EXPOSE 1080-1081
+
+# install configurations and test data
+COPY danted /etc/init.d/
+COPY danted-authenticating /etc/init.d/
diff --git a/coin/provisioning/common/linux/testserver/danted/danted b/coin/provisioning/common/linux/testserver/danted/danted
new file mode 100755
index 00000000..1da8203e
--- /dev/null
+++ b/coin/provisioning/common/linux/testserver/danted/danted
@@ -0,0 +1,93 @@
+#! /bin/sh
+### BEGIN INIT INFO
+# Provides: danted
+# Required-Start: $remote_fs $syslog
+# Required-Stop: $remote_fs $syslog
+# Default-Start: 2 3 4 5
+# Default-Stop: 0 1 6
+# Short-Description: SOCKS (v4 and v5) proxy daemon (danted)
+### END INIT INFO
+#
+# dante SOCKS server init.d file. Based on /etc/init.d/skeleton:
+# Version: @(#)skeleton 1.8 03-Mar-1998 miquels@cistron.nl
+
+PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
+DAEMON=/usr/sbin/danted
+NAME=danted
+DESC="Dante SOCKS daemon"
+PIDFILE=/var/run/$NAME.pid
+CONFFILE=/etc/$NAME.conf
+
+test -f $DAEMON || exit 0
+
+set -e
+
+# This function makes sure that the Dante server can write to the pid-file.
+touch_pidfile ()
+{
+ if [ -r $CONFFILE ]; then
+ uid="`sed -n -e 's/[[:space:]]//g' -e 's/#.*//' -e '/^user\.privileged/{s/[^:]*://p;q;}' \
+ $CONFFILE`"
+ if [ -n "$uid" ]; then
+ touch $PIDFILE
+ chown $uid $PIDFILE
+ fi
+ fi
+}
+
+. /lib/lsb/init-functions
+
+case "$1" in
+ start)
+ if ! egrep -cve '^ *(#|$)' \
+ -e '^(logoutput|user\.((not)?privileged|libwrap)):' $CONFFILE > /dev/null
+ then
+ echo "Not starting $DESC: not configured."
+ exit 0
+ fi
+ echo -n "Starting $DESC: "
+ touch_pidfile
+ start-stop-daemon --start --quiet --oknodo --pidfile $PIDFILE --exec $DAEMON -- -D
+ echo "$NAME."
+ ;;
+ stop)
+ echo -n "Stopping $DESC: "
+ start-stop-daemon --stop --quiet --oknodo --pidfile $PIDFILE --exec $DAEMON
+ echo "$NAME."
+ ;;
+ reload|force-reload)
+ #
+ # If the daemon can reload its config files on the fly
+ # for example by sending it SIGHUP, do it here.
+ #
+ # If the daemon responds to changes in its config file
+ # directly anyway, make this a do-nothing entry.
+ #
+ echo "Reloading $DESC configuration files."
+ start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --exec $DAEMON -- -D
+ ;;
+ restart)
+ #
+ # If the "reload" option is implemented, move the "force-reload"
+ # option to the "reload" entry above. If not, "force-reload" is
+ # just the same as "restart".
+ #
+ echo -n "Restarting $DESC: "
+ start-stop-daemon --stop --quiet --pidfile $PIDFILE --exec $DAEMON
+ sleep 1
+ touch_pidfile
+ start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- -D
+ echo "$NAME."
+ ;;
+ status)
+ status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
+ ;;
+ *)
+ N=/etc/init.d/$NAME
+ # echo "Usage: $N {start|stop|restart|reload|force-reload}" >&2
+ echo "Usage: $N {start|stop|restart|force-reload}" >&2
+ exit 1
+ ;;
+esac
+
+exit 0
diff --git a/coin/provisioning/common/linux/testserver/danted/danted-authenticating b/coin/provisioning/common/linux/testserver/danted/danted-authenticating
new file mode 100755
index 00000000..7aa35db6
--- /dev/null
+++ b/coin/provisioning/common/linux/testserver/danted/danted-authenticating
@@ -0,0 +1,97 @@
+#! /bin/sh
+### BEGIN INIT INFO
+# Provides: danted-authenticating
+# Required-Start: $remote_fs $syslog
+# Required-Stop: $remote_fs $syslog
+# Default-Start: 2 3 4 5
+# Default-Stop: 0 1 6
+# Short-Description: SOCKS (v4 and v5) proxy daemon (danted)
+### END INIT INFO
+#
+# dante SOCKS server init.d file. Based on /etc/init.d/skeleton:
+# Version: @(#)skeleton 1.8 03-Mar-1998 miquels@cistron.nl
+
+PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
+DAEMON=/usr/sbin/danted
+NAME=danted-authenticating
+DESC="Dante SOCKS daemon"
+PIDFILE=/var/run/$NAME.pid
+CONFFILE=/etc/$NAME.conf
+DANTED_ARGS="-D -f $CONFFILE"
+
+test -f $DAEMON || exit 0
+
+set -e
+
+# This function makes sure that the Dante server can write to the pid-file.
+touch_pidfile ()
+{
+ if [ -r $CONFFILE ]; then
+ uid="`sed -n -e 's/[[:space:]]//g' -e 's/#.*//' -e '/^user\.privileged/{s/[^:]*://p;q;}' \
+ $CONFFILE`"
+ if [ -n "$uid" ]; then
+ touch $PIDFILE
+ chown $uid $PIDFILE
+ fi
+ fi
+}
+
+. /lib/lsb/init-functions
+
+case "$1" in
+ start)
+ if ! egrep -cve '^ *(#|$)' \
+ -e '^(logoutput|user\.((not)?privileged|libwrap)):' $CONFFILE > /dev/null
+ then
+ echo "Not starting $DESC: not configured."
+ exit 0
+ fi
+ echo -n "Starting $DESC: "
+ touch_pidfile
+ start-stop-daemon --start --quiet --oknodo --pidfile $PIDFILE \
+ --exec $DAEMON -- $DANTED_ARGS
+ echo "$NAME."
+ ;;
+ stop)
+ echo -n "Stopping $DESC: "
+ start-stop-daemon --stop --quiet --oknodo --pidfile $PIDFILE --exec $DAEMON
+ echo "$NAME."
+ ;;
+ reload|force-reload)
+ #
+ # If the daemon can reload its config files on the fly
+ # for example by sending it SIGHUP, do it here.
+ #
+ # If the daemon responds to changes in its config file
+ # directly anyway, make this a do-nothing entry.
+ #
+ echo "Reloading $DESC configuration files."
+ start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE \
+ --exec $DAEMON -- $DANTED_ARGS
+ ;;
+ restart)
+ #
+ # If the "reload" option is implemented, move the "force-reload"
+ # option to the "reload" entry above. If not, "force-reload" is
+ # just the same as "restart".
+ #
+ echo -n "Restarting $DESC: "
+ start-stop-daemon --stop --quiet --pidfile $PIDFILE --exec $DAEMON
+ sleep 1
+ touch_pidfile
+ start-stop-daemon --start --quiet --pidfile $PIDFILE \
+ --exec $DAEMON -- $DANTED_ARGS
+ echo "$NAME."
+ ;;
+ status)
+ status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
+ ;;
+ *)
+ N=/etc/init.d/$NAME
+ # echo "Usage: $N {start|stop|restart|reload|force-reload}" >&2
+ echo "Usage: $N {start|stop|restart|force-reload}" >&2
+ exit 1
+ ;;
+esac
+
+exit 0
diff --git a/coin/provisioning/common/linux/testserver/docker_testserver.sh b/coin/provisioning/common/linux/testserver/docker_testserver.sh
new file mode 100755
index 00000000..a88e89b9
--- /dev/null
+++ b/coin/provisioning/common/linux/testserver/docker_testserver.sh
@@ -0,0 +1,58 @@
+#!/usr/bin/env bash
+
+#############################################################################
+##
+## Copyright (C) 2017 The Qt Company Ltd.
+## Contact: http://www.qt.io/licensing/
+##
+## This file is part of the provisioning scripts of the Qt Toolkit.
+##
+## $QT_BEGIN_LICENSE:LGPL21$
+## Commercial License Usage
+## Licensees holding valid commercial Qt licenses may use this file in
+## accordance with the commercial license agreement provided with the
+## Software or, alternatively, in accordance with the terms contained in
+## a written agreement between you and The Qt Company. For licensing terms
+## and conditions see http://www.qt.io/terms-conditions. For further
+## information use the contact form at http://www.qt.io/contact-us.
+##
+## GNU Lesser General Public License Usage
+## Alternatively, this file may be used under the terms of the GNU Lesser
+## General Public License version 2.1 or version 3 as published by the Free
+## Software Foundation and appearing in the file LICENSE.LGPLv21 and
+## LICENSE.LGPLv3 included in the packaging of this file. Please review the
+## following information to ensure the GNU Lesser General Public License
+## requirements will be met: https://www.gnu.org/licenses/lgpl.html and
+## http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
+##
+## As a special exception, The Qt Company gives you certain additional
+## rights. These rights are described in The Qt Company LGPL Exception
+## version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
+##
+## $QT_END_LICENSE$
+##
+#############################################################################
+
+set -ex
+
+# Using SHA-1 of each server context as the tag of docker images. A tag labels a
+# specific image version. It is used by docker compose file (docker-compose.yml)
+# to launch the corresponding docker containers. If one of the server contexts
+# (./apache2, ./danted, ...) gets changes, all the related compose files in
+# qtbase should be updated as well.
+#
+# For example, here's how to get the SHA-1 of apache test server.
+# find ./apache2 -type f -print0 | sort -z | xargs -r0 sha1sum | \
+# awk '{ print $1 }' | sha1sum | awk '{ print $1 }'
+
+testserver='apache2 squid vsftpd ftp-proxy danted'
+
+for server in $testserver
+do
+ context="${BASH_SOURCE%/*}/$server"
+ sha1=$(find $context -type f -print0 | sort -z | xargs -r0 sha1sum | awk '{ print $1 }' | \
+ sha1sum | awk '{ print $1 }')
+ sudo docker build -t qt-test-server-$server:$sha1 $context
+done
+
+sudo docker images
diff --git a/coin/provisioning/common/linux/testserver/ftp-proxy/Dockerfile b/coin/provisioning/common/linux/testserver/ftp-proxy/Dockerfile
new file mode 100644
index 00000000..2bf9220b
--- /dev/null
+++ b/coin/provisioning/common/linux/testserver/ftp-proxy/Dockerfile
@@ -0,0 +1,3 @@
+FROM ubuntu:16.04
+RUN apt-get update && apt-get install -y ftp-proxy=1.9.2.4-10
+EXPOSE 2121
diff --git a/coin/provisioning/common/linux/testserver/squid/Dockerfile b/coin/provisioning/common/linux/testserver/squid/Dockerfile
new file mode 100644
index 00000000..c4256f48
--- /dev/null
+++ b/coin/provisioning/common/linux/testserver/squid/Dockerfile
@@ -0,0 +1,3 @@
+FROM ubuntu:16.04
+RUN apt-get update && apt-get install -y squid=3.5.12-1ubuntu7.5
+EXPOSE 3128-3130
diff --git a/coin/provisioning/common/linux/testserver/vsftpd/Dockerfile b/coin/provisioning/common/linux/testserver/vsftpd/Dockerfile
new file mode 100644
index 00000000..58ca6cff
--- /dev/null
+++ b/coin/provisioning/common/linux/testserver/vsftpd/Dockerfile
@@ -0,0 +1,6 @@
+FROM ubuntu:16.04
+RUN apt-get update && apt-get install -y vsftpd=3.0.3-3ubuntu2 ftp=0.17-33 wget
+EXPOSE 20-21
+
+# install configurations and test data
+RUN wget https://tools.ietf.org/rfc/rfc3252.txt